unit IFMIDI;

interface
uses
    Sysutils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
    Forms, Dialogs, StdCtrls, MPlayer, ExtCtrls, Gauges;

type
      TMidiPanel=class(TPanel)
        MP : TMediaPlayer;
        Timer:TTimer;
        Gauge:TGauge;
        LabLit,LabVal : TLabel;
        constructor Create(AOwner:TWinControl; Media:TMediaPlayer);
        procedure Open;
        procedure MPTime(Sender:TObject);
        procedure MPClick(Sender:TObject; Button:TMPBtnType; var DoDefault:boolean);
      end;

implementation

constructor TMidiPanel.Create(AOwner:TWinControl;Media:TMediaPlayer);
begin
     inherited create(AOwner);
     parent:= AOwner;
     MP:=Media;
     MP.Onclick:=MPClick;
     Timer:=TTimer.Create(Self);
     Timer.Interval:=100;
     Timer.Enabled:=False;
     Timer.Ontimer:=MPTime;
     Left:=192;
     Top:=MP.Top+MP.Height+5;
     Height:=Parent.ClientHeight-Top-7;
     Width:=170;

     { Label for MIDI length file }
     LabLit:=TLabel.Create(Self);
     with LabLit do
     begin
          parent:=self;
          top:=2;
          left:=5;
          caption:='Length :';
     end;

     { Label for display length value }
     LabVal:=TLabel.Create(self);
     with LabVal do
     begin
          parent:=self;
          top:=2;
          left:=Self.Width-85;
          alignment:=taRightJustify;
          caption:='0';
     end;

     { Create the progress gauge }
     Gauge:=TGauge.Create(self);
     with Gauge do
     begin
          parent:=self;
          top:=17;
          left:=5;
          width:=Self.Width-10;
          height:=15;
          BackColor:=clNavy;
          ForeColor:=clLime;
          Progress:=0;
     end;
end;


procedure TMidiPanel.Open;
var Minutes, Seconds,temp : longint;
begin
     try
        MP.Open;
     except
        messageDlg('Could not open file',mtWarning,[mbOK],0);
        exit;
     end;

     { Convert to Minutes:Seconds}
     temp:=round(MP.Length / 6.6);
     Minutes:=temp div 60;
     Seconds:=temp mod 60;

     { Display length of this MIDI file in M:S format }
     LabVal.Caption:=IntToStr(Minutes)+':'+IntToStr(Seconds);
end;

procedure TMidiPanel.MPTime(Sender:TObject);
var len:longint;
begin
     Gauge.Progress:=MP.Position*100 div MP.Length;
end;

procedure TMidiPanel.MPClick(Sender : TObject; Button:TMPBtnType; var DoDefault:Boolean);
begin
     if Button=btPlay then
        Timer.Enabled:=true;
end;
end.
